#!/usr/bin/perl
###############################################################################
#
#   Copyright (C) 2010-2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.
#
###############################################################################
use strict;
use warnings;
use File::Copy;
use POSIX;
use IPC::Open3;
use Getopt::Long;
use IO::Select;
use FileHandle;
use FindBin;

use lib "$FindBin::Bin/lib/perl5";
use Moab::Build::Common;
use Moab::Build::Process;
use Moab::Build::DBInstallerInfo;

sub usage{
  println("USAGE: uninstall.sqlite3.pl [--noprompt] Moab-Home-Directory");
  exit(-1);
}

my $noprompt = 0;
GetOptions(
  "noprompt" => \$noprompt,
);

my ($moabHomeDir) = @ARGV;

usage() unless defined($moabHomeDir);
verifyDirectory($moabHomeDir, "Specified Moab home directory");

my ($driver, $uninstallFunction) = Moab::Build::DBInstallerInfo::getUninstallInfo("SQLite3", $moabHomeDir, undef, $noprompt);

$uninstallFunction->();
1;
__END__

=head1 NAME

=head1 SYNOPSIS

=head1 DESCRIPTION

=head2 EXPORT

=head2 EXPORT_OK

=head1 SEE ALSO

Additional information can be found at http://www.adaptivecomputing.com/

=head1 AUTHOR

Adaptive Computing, Inc., E<lt>http://www.adaptivecomputing.com/E<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2010-2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

=cut
