package Moab::RMConfig::DSTAGE;
#################################################################################
# Configuration file for dstage tools
#
#   Copyright (C) 2005-2014 by Adaptive Computing Enterprises, Inc. All Rights Reserved.
#
################################################################################

#use strict;
#use warnings;
use Moab::Tools qw($homeDir);
use Exporter;
our @ISA = qw(Exporter);
our @EXPORT_OK = qw($monitor $delim);

# Default values - Please use update-rmconfig to change these values
#DEFAULT########################################################################
our $PATH = "$ENV{PATH}";
our $dataFileSpool = "$homeDir/spool/datafiles.txt";
our $dataSpaceSpool = "$homeDir/spool/dataspaces.txt";
our $dataSpaceUser = "user";
our $dataSpacesFile = "$homeDir/dataspaces.tab";
our $endPurgeDuration = "600";
our $logLevel = "1";
our $pollInterval = "30";
our $remoteCopy = "scp";
our $remoteExec = "ssh";
our $removePurgeDuration = "300";
our $startPurgeDuration = "604800";
push @EXPORT_OK, qw( $PATH $dataFileSpool $dataSpaceSpool $dataSpaceUser $dataSpacesFile $endPurgeDuration $logLevel $pollInterval $remoteCopy $remoteExec $removePurgeDuration $startPurgeDuration );
#DEFAULT#END####################################################################

$ENV{PATH} = $PATH;
# The monitor is the daemon that updates the dataspace spool
our $monitor = "__mon.dstage.pl";
# Delimeter inserted before actual output of remote command (helps work around banners/dmesg's)
our $delim = "--MBEGIN--";

# Specify level of log detail
#$logLevel = 1;
#
# The data spool maintains information about staging data files
# Format: <destination url>|<job id> BYTESTRANSFERRED=<bytes transferred> ENDTIME=<end time> FILESIZE=<file size> REMOVETIME=<remove time> SOURCEURL=<source url> STARTTIME=<start time> STATE=Pending|Staged|Failed USER=<user name> ERROR="<error msg>"
#$dataFileSpool = "${homeDir}/spool/datafiles.txt";
#
# The end point spool maintains information about available disk for staging
# Format: <destination url> STATE=Idle CDISK=<configured disk> ADISK=<available disk> CRES=Bandwidth:<bandwidth> TRANSFERRATE=<transfer rate>
#$dataSpaceSpool = "${homeDir}/spool/dataspaces.txt";
#
# Path to remote execution command (one of: { ssh, globus-job-run })
#$remoteExec = `which ssh`;
#chomp $remoteExec;
#
# Path to remote copy command (one of: { scp, globus-url-copy })
#$remoteCopy = `which scp`; 
#chomp $remoteCopy;
#
# The Data Spaces File lists static per dataspace properties
# Format:
#$dataSpacesFile  = "${homeDir}/dataspaces.tab";
#
# The user enabled to check the available disk space for all data spaces
#$dataSpaceUser = "josh";
#
# Time to wait (in seconds) after data staging has started to purge data entry
#$startPurgeDuration = 604800;
#
# Time to wait (in seconds) after data staging has ended to purge data entry
#$endPurgeDuration = 600;
#
# Time to wait (in seconds) after data has been removed to purge data entry
#$removePurgeDuration = 300;
#
# How often should the monitor poll to the dataspace spool
#$pollInterval = 30;

1; # Required -- Do not remove
__DATA__
$PATH
$logLevel
$dataFileSpool
$dataSpaceSpool
$remoteExec
$remoteCopy
$dataSpacesFile
$dataSpaceUser
$startPurgeDuration
$endPurgeDuration
$removePurgeDuration
$pollInterval


__END__

=head1 NAME

=head1 SYNOPSIS

=head1 DESCRIPTION

=head2 EXPORT

=head2 EXPORT_OK

=head1 SEE ALSO

Additional information can be found at http://www.adaptivecomputing.com/

=head1 AUTHOR

Adaptive Computing, Inc., E<lt>http://www.adaptivecomputing.com/E<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2005-2014 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

=cut
