package Moab::RMConfig::IPMI;
#################################################################################
# Configuration file for IPMI
#
#   Copyright (C) 2006-2014 by Adaptive Computing Enterprises, Inc. All Rights Reserved.
#
################################################################################

#use strict;
#use warnings;
use Exporter;
our @ISA = qw(Exporter);
our @EXPORT_OK = ();

# Default values - Please use update-rmconfig to change these values
#DEFAULT########################################################################
our $bmcaddrmap = "node-bmc.txt";
our $ipmifile = "ipmicache.gm";
our $ipmipass = "admin";
our $ipmiuser = "admin";
our $pollInterval = "180";
push @EXPORT_OK, qw( $bmcaddrmap $ipmifile $ipmipass $ipmiuser $pollInterval );
#DEFAULT#END####################################################################

# The name of the ipmi daemon script
our $daemon = '__mon.ipmi.pl';

# The name of the file to store sensor data
#$ipmifile = "ipmicache.gm";
#
# How often should the monitor poll to update the job and node spools
#$pollInterval = 180;
#
# The file that contains the mapping from cluster node to BMC IP address
#$bmcaddrmap = "node-bmc.txt";
#
# IPMI LAN username and password
#$ipmiuser = "admin";
#$ipmipass = "admin";

1; # Required -- Do not remove
__DATA__
$ipmifile
$pollInterval
$bmcaddrmap
$ipmiuser
$ipmipass

__END__

=head1 NAME

=head1 SYNOPSIS

=head1 DESCRIPTION

=head2 EXPORT

=head2 EXPORT_OK

=head1 SEE ALSO

Additional information can be found at http://www.adaptivecomputing.com/

=head1 AUTHOR

Adaptive Computing, Inc., E<lt>http://www.adaptivecomputing.com/E<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2006-2014 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

=cut
