package Moab::RMConfig::SGE;
#################################################################################
# Configuration file for sge tools
#
#   Copyright (C) 2006-2014 by Adaptive Computing Enterprises, Inc. All Rights Reserved.
#
################################################################################

#use strict;
#use warnings;
use Exporter;
our @ISA = qw(Exporter);
our @EXPORT_OK = qw();

# Default values - Please use update-rmconfig to change these values
#DEFAULT########################################################################
our $PATH = "$SGE_ROOT/bin/lx24-x86:/opt/moab/bin;$ENV{'PATH'}";
our $SGE_ROOT = "/opt/sge-root";
our $logLevel = "1";
our $mdiag = "mdiag";
our $primaryQueue = "all.q";
our $procsPerNode = "2";
our $qalter = "qalter";
our $qconf = "qconf";
our $qdel = "qdel";
our $qhost = "qhost";
our $qstat = "qstat";
our $qsub = "qsub";
our $startingDuration = "30";
push @EXPORT_OK, qw( $PATH $SGE_ROOT $logLevel $mdiag $primaryQueue $procsPerNode $qalter $qconf $qdel $qhost $qstat $qsub $startingDuration );
#DEFAULT#END####################################################################

$ENV{'SGE_ROOT'} = $SGE_ROOT;
$ENV{'PATH'} = $PATH;

# Map months of year to array indexes for timelocal
# TODO: Fix scripts to properly reference Moab::Tools for this information
#our %month = (
#    Jan => 0,
#    Feb => 1,
#    Mar => 2,
#    Apr => 3,
#    May => 4,
#    Jun => 5,
#    Jul => 6,
#    Aug => 7,
#    Sep => 8,
#    Oct => 9,
#    Nov => 10,
#    Dec => 11
#);

# Specify level of log detail
#$logLevel = 1;
#
# Amount of time we will give the scheduler to get a job started after a qrun
# A reasonable value might be about twice the SGE scheduling interval
#$startingDuration = 30;
#
# Processors per Node in cluster
#$procsPerNode = 2;
#
# Primary SGE Queue that all job will be submitted to
# This queue needs to be defined in both Moab and SGE (disabled in SGE)
#$primaryQueue = "all.q";
#
# Set paths as necessary -- these can be short names if PATH is included above
#$qstat  = "qstat";
#$qhost  = "qhost";
#$qconf  = "qconf";
#$qalter = "qalter";
#$qdel   = "qdel";
#$qsub   = "qsub";
#$mdiag  = "mdiag";
#

1; # Required -- Do not remove
__DATA__
$SGE_ROOT
$PATH
$logLevel
$startingDuration
$procsPerNode
$primaryQueue
$qstat
$qhost
$qconf
$qalter
$qdel
$qsub
$mdiag


__END__

=head1 NAME

=head1 SYNOPSIS

=head1 DESCRIPTION

=head2 EXPORT

=head2 EXPORT_OK

=head1 SEE ALSO

Additional information can be found at http://www.adaptivecomputing.com/

=head1 AUTHOR

Adaptive Computing, Inc., E<lt>http://www.adaptivecomputing.com/E<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2006-2014 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

=cut
