package Moab::RMConfig::VLAN;
#################################################################################
# Configuration file for vlan tools
#
#   Copyright (C) 2005-2014 by Adaptive Computing Enterprises, Inc. All Rights Reserved.
#
################################################################################

#use strict;
#use warnings;
use Moab::Tools qw($homeDir);
use Exporter;
our @ISA = qw(Exporter);
our @EXPORT_OK = ();

# Default values - Please use update-rmconfig to change these values
#DEFAULT########################################################################
our $PATH = "$ENV{PATH}";
our $capacity = "100";
our $destroyScript = "/opt/moab/tools/__net.vlan-destroy.ciscoios.expect";
our $globalVlanId = "1";
our $logLevel = "1";
our $loginPrompt = "ops-test-switch";
our $nodesFile = "/opt/moab/nodes.tab";
our $password = "ops-test-switch";
our $router = "switch-10.0.1.218";
our $secret = "priv_node_password";
our $timeout = "5";
push @EXPORT_OK, qw( $PATH $capacity $destroyScript $globalVlanId $logLevel $loginPrompt $nodesFile $password $router $secret $timeout );
#DEFAULT#END####################################################################

$ENV{PATH} = $PATH;

# Specifies level of logging detail
#$logLevel = 1;
#
# The Nodes File lists per node properties (such as PORT, ROUTER)
# FORMAT: node01 PORT=Gi1/0/2 ROUTER=my_router
#$nodesFile  = "${homeDir}/nodes.tab";
#
# Password for logging into the switch router
#$password = "ops-test-switch";
#
# Password for logging into the switch router
#$loginPrompt = "ops-test-switch";
#
# Enable secret for privileged mode access
#$secret = "priv_node_password";
#
# (Expect) script that destroys VLANs
#$destroyScript = "$Bin/__net.vlan-destroy.ciscoios.expect";
#
# hostname or IP Address of Router
#$router = "switch-10.0.1.218";
#
# if globalVlanId is set, move allocated hosts to global VLAN on 'destroy'
#$globalVlanId = "1";
#
# Time out for spawned command responsiveness
#$timeout = "5";
#
# What is the fully utilized capacity of the switch router (in gigabits/sec)
#$capacity = "100";

1; # Required -- Do not remove
__DATA__
$PATH
$logLevel
$nodesFile
$password
$loginPrompt
$secret
$destroyScript
$router
$globalVlanId
$timeout
$capacity

__END__

=head1 NAME

=head1 SYNOPSIS

=head1 DESCRIPTION

=head2 EXPORT

=head2 EXPORT_OK

=head1 SEE ALSO

Additional information can be found at http://www.adaptivecomputing.com/

=head1 AUTHOR

Adaptive Computing, Inc., E<lt>http://www.adaptivecomputing.com/E<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2005-2014 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

=cut
