#!/usr/bin/python

#THIS SOFTWARE SCRIPT IS PROVIDED BY ADAPTIVE COMPUTING ENTERPRISES, INC. "AS IS" 
#AND IS FOR REFERENCE USE ONLY.  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT 
#NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
#PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ADAPTIVE COMPUTING ENTERPRISES, INC. 
#BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
#DAMAGES ARISING FROM THE USE THEREOF.

# Modification for Cray XC systems
# =============================================================================
# THIS SCRIPT HAS BEEN MODIFIED TO SERVE AS A "REFERENCE" SCRIPT FOR USE WITH
# CRAY XC SYSTEMS.  IT WILL REQUIRE MODIFICATION TO WORK WITH A SPECIFIC CRAY.
# =============================================================================

import os

class Config:
  def __init__(self):
    self.start = False
    self.restart = False
    self.entries = {}

    # Moab home and tool directory; change if necessary.
    # IMPORTANT! - There MUST be a '/' on the end of self.homeDir and
    #              self.toolsDir.
    self.homeDir = "/opt/moab/"
    self.toolsDir = "/opt/moab/tools/"

    # For Cray XC capmc commands, these variables (or other authentication)
    # must be in place. It is recommended that you copy the .crt and .key files
    # from <your cray>-smw node to self.homeDir/ssl. Note you MUST replace the
    # "https://kachina-smw.us.cray.com:8443" URL with the URL appropriate to
    # your Cray system.

    # Define which capmc command/version to use.
    # If the server is configured to "module load capmc" on boot, you may may
    # simply set self.capmcCommand to "capmc" 
    self.capmcCommand = "/opt/cray/capmc/default/bin/capmc"

    os.environ["OS_CACERT"] = self.homeDir + "ssl/certificate_authority.crt"
    os.environ["OS_KEY"] = self.homeDir + "ssl/client.key"
    os.environ["OS_CERT"]= self.homeDir + "ssl/client.crt"
    os.environ["OS_SERVICE_URL"] = "https://kachina-smw.us.cray.com:8443"
