#!/usr/bin/python
#THIS SOFTWARE SCRIPT IS PROVIDED BY ADAPTIVE COMPUTING ENTERPRISES, INC. "AS IS" 
#AND IS FOR REFERENCE USE ONLY.  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT 
#NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
#PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ADAPTIVE COMPUTING ENTERPRISES, INC. 
#BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
#DAMAGES ARISING FROM THE USE THEREOF.

# Modification for Cray XC systems
#==============================================================================
# THIS SCRIPT HAS BEEN MODIFIED TO SERVE AS A "REFERENCE" SCRIPT FOR USE WITH
# CRAY XC SYSTEMS.  IT MAY REQUIRE MODIFICATION TO WORK WITH A SPECIFIC CRAY.
#
# This script simply calls knl.reconfigure.reboot.py in an independent process.
# Please refer to knl.reconfigure.reboot.py for details.
#==============================================================================
from __future__ import print_function

import os, sys, argparse, time, subprocess, json, time

knl_configurations = [
    'OS=CLE_a2a_flat',
    'OS=CLE_a2a_equal',
    'OS=CLE_a2a_split',
    'OS=CLE_a2a_cache',
    'OS=CLE_snc2_flat',
    'OS=CLE_snc2_equal',
    'OS=CLE_snc2_split',
    'OS=CLE_snc2_cache',
    'OS=CLE_snc4_flat',
    'OS=CLE_snc4_equal',
    'OS=CLE_snc4_split',
    'OS=CLE_snc4_cache',
    'OS=CLE_hemi_flat',
    'OS=CLE_hemi_equal',
    'OS=CLE_hemi_split',
    'OS=CLE_hemi_cache',
    'OS=CLE_quad_flat',
    'OS=CLE_quad_equal',
    'OS=CLE_quad_split',
    'OS=CLE_quad_cache',
]

#==============================================================================
# Define CLI options
#==============================================================================
parser = argparse.ArgumentParser()

nodes_help="one or more nodes (comma separated) to reconfigure and reboot"
parser.add_argument(
    "nodes",
    help=nodes_help
)

set_help_string = """Specify the OS name that represents the required NUMA and
    MCDRAM configuration. Example: --set <ATTR>=<VALUE>, where <ATTR>=<VALUE> is
    one of the following: %s""" % ', '.join(knl_configurations)
parser.add_argument(
    '--set',
    help=set_help_string,
    metavar="KNL OS name",
    dest="os",
    choices=knl_configurations
)

args = parser.parse_args()

#knl_reconfigure_reboot_command = "%s/knl.reconfigure.reboot.py %s --set %s" % (
#    os.path.dirname(os.path.realpath(__file__)), args.nodes, args.os)

knl_reconfigure_reboot_command = "%s/knl.reconfigure.reboot.py" % (
    os.path.dirname(os.path.realpath(__file__)))

#DEBUG ONLY:
print("knl_reconfigure_reboot_command = %s" % knl_reconfigure_reboot_command, file=sys.stdout)

knl_reprovision_process = subprocess.Popen(
    [knl_reconfigure_reboot_command, args.nodes, "--set", args.os],
    stdout=None, stderr=None, stdin=None)

#DEBUG ONLY:
print("pid = %i" % knl_reprovision_process.pid, file=sys.stdout)
