#!/usr/bin/python

#THIS SOFTWARE SCRIPT IS PROVIDED BY ADAPTIVE COMPUTING ENTERPRISES, INC. "AS IS" 
#AND IS FOR REFERENCE USE ONLY.  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT 
#NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
#PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ADAPTIVE COMPUTING ENTERPRISES, INC. 
#BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
#DAMAGES ARISING FROM THE USE THEREOF.

import os
import os.path
from config import Config
import time
import sys, string
import subprocess
#import xml.etree.ElementTree as xml
import xml.etree.ElementTree as ET

def monitor():


#  cmd = 'mdiag -n --format=xml'
#
#  p = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
#  retval = p.wait()
#  result = p.stdout.read()
#
## Read all nodes from the mdiag -n output 
#
#  root = ET.fromstring(result)
#  nodelist = root.findall("node")
#  for elem in nodelist:
#    print elem.get('NODEID')
#    nodes.append(elem.get('NODEID'))

# Read all nodes & bmc host names from the bmcaddrmap


# Open the output file for write 
  tmpFileName = cfg.homeDir + "spool/" + cfg.ipmifile + ".tmp"
  finalFileName = cfg.homeDir + "spool/" + cfg.ipmifile 
  outputFile = open(tmpFileName, 'w')



# For each entry, call the ipmitool command 

  for(left, right) in cfg.entries.items():

#   ipmitool -I lan -H <host> -U <username> -f <password file> sdr type temperature
    basecmd = "ipmitool -I lan -H " + right + " -U " + cfg.ipmiuser + " -f " + cfg.ipmipass  
    sensorcmd = basecmd + " sdr type temperature";
    powercmd = basecmd + " chassis power status";

# Execute the ipmitool command for temperature 

    p = subprocess.Popen(sensorcmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    retval = p.wait()
    results = p.stdout.readlines()

    output = left + " "

#   EXPECTED RESULTS 
#         "System Temp      | 11h | ok  |  7.1 | 29 degrees C"
#         "CPU Temp         | 12h | ok  |  3.1 | 32 degrees C"
#
#   Handle errors for either no results or the word "failed" in the output
    if len(results) == 0:
      continue

    if results[0].find("Error:") >= 0 or results[0].find("error") >= 0 or results[0].find("failed") >= 0:
      continue

#   Parse results and write to output file 
    for result in results:
      if result.find("Temp") != -1 and result.find("degrees C") != -1:
        values = result.split('|')
        values[0] = values[0].strip()                 #Strip all trailing spaces.
        values[0] = values[0].replace(' ','_')        #Replace space in "System Temp" to "System_Temp"
        output += " GMETRIC[" + values[0]+ "]=" + values[4].split()[0]

# Execute the ipmitool command for power 

    p = subprocess.Popen(powercmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    retval = p.wait()
    results = p.stdout.readlines()
  
#   EXPECTED RESULTS:
#       "Chassis Power is on"

#   Handle errors for either no results or the word "failed" in the output
    if len(results) == 0:
      continue
    breakFlag = False
    for result in results:
      if result.find("failed") != -1:
        breakFlag = True
    if breakFlag == True:
      continue

# Validate the data "Chassis Power is <on|off>.  Anything else is bad data.
    result = results[0]
    values = result.split()
    if values[0] == "Chassis" and values[1] == "Power" and values[2] == "is":
      output += " POWER=" + values[3].strip()
    else:
      continue

# uncomment this line if Moab is ignoring the output of this script (MOAB-7607)
#    output += " State=Unknown"
    outputFile.write(output +'\n')

  
  outputFile.close()

# rename the tmp file to the final file 

  cmd = "mv " + tmpFileName + " " + finalFileName
  p = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
  retval = p.wait()
###############################################

cfg = Config()


#Check stop option or restart and verify pidfile exists 
if (cfg.restart and os.path.isfile(pidFile)):
# Get the pid from the file
  cfg.kill_pid()

  if stop:
    sys.exit(0)

# check to see if we are starting or restart program.
if (cfg.start or cfg.restart):

# check to see if program is running & destroy it.
  if (os.path.isfile(cfg.pidFile)):
    f = open(cfg.pidFile)
    lines = f.readlines()
    f.close()

    if len(lines) > 0:
      cmd = "kill -0 " + lines[0]
      subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)

#Daemonize
  child_pid = os.fork()
  if (child_pid != 0):
    os._exit(0)
  os.setpgrp()

#write the pid to file
  
  f = open(cfg.pidFile,'w')
  pid = os.getpid();
  f.write(str(pid))
  f.close()

  while (True):
    monitor()
    time.sleep(cfg.pollInterval)

else:

# Called without start option. So run monitor and exit
  monitor()
  sys.exit(0)








