#!/usr/bin/python

#THIS SOFTWARE SCRIPT IS PROVIDED BY ADAPTIVE COMPUTING ENTERPRISES, INC. "AS IS" 
#AND IS FOR REFERENCE USE ONLY.  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT 
#NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
#PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ADAPTIVE COMPUTING ENTERPRISES, INC. 
#BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
#DAMAGES ARISING FROM THE USE THEREOF.

# Modification for Cray XC systems
#==============================================================================
# THIS SCRIPT HAS BEEN MODIFIED TO SERVE AS A "REFERENCE" SCRIPT FOR USE WITH
# CRAY XC SYSTEMS.  IT MAY REQUIRE MODIFICATION TO WORK WITH A SPECIFIC CRAY.
#==============================================================================
# Modified to use Cray XC capmc commands instead of ipmitool commands.
# Currently without the temperature readings - uses fixed text instead
#==============================================================================

import os
import os.path
from config import Config
import time
import sys, string
import subprocess
#import xml.etree.ElementTree as xml
import xml.etree.ElementTree as ET

import json

def print_nid(outputFile, nid, pwr):
    # NOTE:  Telling Moab that 'State=Unknown' is important.
    # output = "nid%d POWER=%s State=Unknown\n" % (nid, pwr)
    output = "%d POWER=%s State=Unknown\n" % (nid, pwr)
    outputFile.write(output)
#--


def monitor():

    #==============================================================================
    # Following original reference code commented out
    #==============================================================================
    #   cmd = 'mdiag -n --format=xml'
    #
    #   p = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    #   retval = p.wait()
    #   result = p.stdout.read()
    #
    ## Read all nodes from the mdiag -n output 
    #
    #   root = ET.fromstring(result)
    #   nodelist = root.findall("node")
    #   for elem in nodelist:
    #     print elem.get('NODEID')
    #     nodes.append(elem.get('NODEID'))
    #==============================================================================
    # No need to:
    # Read all nodes & bmc host names from the bmcaddrmap file
    #==============================================================================

    # Open the output file for write 
    tmpFileName = cfg.homeDir + "spool/" + cfg.ipmifile + ".tmp"
    finalFileName = cfg.homeDir + "spool/" + cfg.ipmifile 
    outputFile = open(tmpFileName, 'w')

    # Use the full list of nodes that comes back from one invocation of capmc node_status
    # was TEST ONLY:
    # capmcCmd="cat out/x.status"
    capmcCmd="capmc node_status"

    # Execute the capmc command for nidlist and status 
    p = subprocess.Popen(capmcCmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    retval = p.wait()

#   EXPECTED RESULTS, e.g.,
#   {
#    "e": 0, 
#    "err_msg": "", 
#    "off": [
#	6
#	]
#    "ready": [
#        1,
#        2,
#        4,
#        5
#     ]
#    }
#

    jinfo = json.load(p.stdout)
    # TODO: close?
    #p.close()

#   Parse results and write to output file 
    if "ready" in jinfo:
	for nid in jinfo["ready"]:
	    print_nid(outputFile, nid, "on")
  
    # an intermediate state, power is on, but system not ready:
    if "on" in jinfo:
	for nid in jinfo["on"]:
	    print_nid(outputFile, nid, "on")
  
    # in this state, power is off
    if "off" in jinfo:
	for nid in jinfo["off"]:
	    print_nid(outputFile, nid, "off")

    outputFile.close()

# rename the tmp file to the final file 
    cmd = "mv " + tmpFileName + " " + finalFileName
    p = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    retval = p.wait()
###############################################


#----------------------------------------------
# "main"
#----------------------------------------------
cfg = Config()


#Check stop option or restart and verify pidfile exists 
if (cfg.restart and os.path.isfile(pidFile)):
# Get the pid from the file
  cfg.kill_pid()

  if stop:
    sys.exit(0)

# check to see if we are starting or restart program.
if (cfg.start or cfg.restart):

# check to see if program is running & destroy it.
  if (os.path.isfile(cfg.pidFile)):
    f = open(cfg.pidFile)
    lines = f.readlines()
    f.close()

    if len(lines) > 0:
      cmd = "kill -0 " + lines[0]
      subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)

#Daemonize
  child_pid = os.fork()
  if (child_pid != 0):
    os._exit(0)
  os.setpgrp()

#write the pid to file
  
  f = open(cfg.pidFile,'w')
  pid = os.getpid();
  f.write(str(pid))
  f.close()

  while (True):
    monitor()
    time.sleep(cfg.pollInterval)

else:

# Called without start option. So run monitor and exit
  monitor()
  sys.exit(0)

