#!/usr/bin/python

#THIS SOFTWARE SCRIPT IS PROVIDED BY ADAPTIVE COMPUTING ENTERPRISES, INC. "AS IS" 
#AND IS FOR REFERENCE USE ONLY.  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT 
#NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
#PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ADAPTIVE COMPUTING ENTERPRISES, INC. 
#BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
#DAMAGES ARISING FROM THE USE THEREOF.

import subprocess,sys
import os
import getopt
from config import Config

# Report if monitor is loaded by doing a 'ps -ef | grep <monfile>'

cfg = Config()

helpmsg = 'ipmi.mon.py --start|-s --stop|-k --restart|-r --help|-h|-?'

try:
  opts, args = getopt.getopt(sys.argv[1:],"skrh?",["start","stop","restart","help"])
except getopt.GetoptError:
  print helpmsg
  sys.exit(2)

for opt, arg in opts:
  if opt in ("-h", "-?", "--help"):
    print helpmsg
    sys.exit(0)
  elif opt in ("-s", "--start"):
    cfg.start = True
  elif opt in ("-k", "--stop"):
    cfg.kill_pid()
    sys.exit(0)

  elif opt in ("-r", "--restart"):
    cfg.restart = True

# the [Ss] in the grep is a trick to remove the grep from the ps output
cmd = "ps -ef | grep " + cfg.daemon + " | grep [Ss]tart"
p = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
retval = p.wait()
result = p.stdout.readlines()

# process not found means we need to start it up:
if retval > 0:
  cmd = cfg.daemon  + " --start" 
  subprocess.call(cmd, shell=True)
#  p = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
  sys.exit(0)

else:

  # if the pid file isn't there, recreate it since we just did the ps
  if os.path.exists(cfg.pidFile) == False:
    psline = result[0].split()
    f = open(cfg.pidFile, 'w')
    f.write(psline[1])
    f.close()

# Open the results file and print the data

  f = open(cfg.homeDir + "spool/" + cfg.ipmifile)
  lines = f.readlines()
  f.close()

  for line in lines:
    print line.strip()
