#!/usr/bin/python

#THIS SOFTWARE SCRIPT IS PROVIDED BY ADAPTIVE COMPUTING ENTERPRISES, INC. "AS IS" 
#AND IS FOR REFERENCE USE ONLY.  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT 
#NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
#PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ADAPTIVE COMPUTING ENTERPRISES, INC. 
#BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
#DAMAGES ARISING FROM THE USE THEREOF.

# Modification for Cray XC systems
#==============================================================================
# THIS SCRIPT HAS BEEN MODIFIED TO SERVE AS A "REFERENCE" SCRIPT FOR USE WITH
# CRAY XC SYSTEMS.  IT MAY REQUIRE MODIFICATION TO WORK WITH A SPECIFIC CRAY.
#==============================================================================

import sys, getopt, string
from config import Config
import subprocess

if (len(sys.argv) < 2):
  print "ERROR: Expected arguments: <node> <status>\n"
  sys.exit(1)

cfg = Config()

innode = sys.argv[1]
stat = sys.argv[2].lower()

if (stat == "reboot"):
  stat = "reset"

if ((stat != "reset") and (stat != "on") and (stat != "off")):
  print "ERROR: Requested state: " + stat + " is not valid. \n"
  sys.exit(1)

# node may come as a comma separated list, like: "node1,node2,node3"
# reduce the list to just numbers.
# allow either "nidxxx" or "nodexxx"
innode=innode.replace("node","")
innode=innode.replace("nid","")


# Modification for Cray XC systems
#==============================================================================
# ipmitool -I lan -H <host> -U <username> -f <password file> chassis power <off|on>
# basecmd = "ipmitool -I lan -H " + bmchost + " -U " + cfg.ipmiuser + " -f " + cfg.ipmipass  
# powercmd = basecmd + " chassis power " + stat;
#
# was TEST ONLY:
# powercmd = "echo capmc node_%s --nids %s >> /tmp/x.x" % (stat, innode)
powercmd = "capmc node_%s --nids %s" % (stat, innode)
#==============================================================================

#DEBUG ONLY:
print powercmd
 
p = subprocess.Popen(powercmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
retval = p.wait()
# DEBUG ONLY:
results = p.stdout.readlines()
print results

sys.exit(0)

