#!/usr/bin/python

#THIS SOFTWARE SCRIPT IS PROVIDED BY ADAPTIVE COMPUTING ENTERPRISES, INC. "AS IS" 
#AND IS FOR REFERENCE USE ONLY.  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT 
#NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
#PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ADAPTIVE COMPUTING ENTERPRISES, INC. 
#BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
#DAMAGES ARISING FROM THE USE THEREOF.

import sys, getopt, string
from config import Config
import subprocess

if (len(sys.argv) < 2):
  print "ERROR: Expected arguments: <node> <status>\n"
  sys.exit(1)

cfg = Config()

innode = sys.argv[1]
stat = sys.argv[2].lower()

if (stat == "reboot"):
  stat = "reset"

if ((stat != "reset") and (stat != "on") and (stat != "off")):
  print "ERROR: Requested state: " + stat + " is not valid. \n"
  sys.exit(1)

# Loop through each node that may come as a comma seperated list, like: "node1,node2,node3"
lines = innode.split(',')
for node in lines:

# Get the ipmp host/IP addr for the node specified.
  bmchost = cfg.entries.get(node)
  if (bmchost == None):
    print "ERROR: Requested node " + innode + " does not have associated BMC host/IP address.  Add to " + cfg.bmcaddrmap + ".\n"
    continue

# ipmitool -I lan -H <host> -U <username> -f <password file> chassis power <off|on>
  basecmd = "ipmitool -I lan -H " + bmchost + " -U " + cfg.ipmiuser + " -f " + cfg.ipmipass  
  powercmd = basecmd + " chassis power " + stat;
 
  p = subprocess.Popen(powercmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
  retval = p.wait()

sys.exit(0)



