#!/usr/bin/python
  
import sys
import zmq
import os

#-----------------------------------------------
# GetFunctionName
#-----------------------------------------------

def GetFunctionName(line):
    sections = line.split(",")
    for section in sections:
        if "Function" in section:
            return section.split(":")[1]

#-----------------------------------------------
# GetDuration
#-----------------------------------------------

def GetDurationText(line):
    sections = line.split(",")
    for section in sections:
        if "Duration" in section:
            tuples = section.split(":")
            return tuples[1].split("\"")[0]

#-----------------------------------------------
# Main
#-----------------------------------------------

tabLevel = 0
subcalls = [ False ]
os.system('clear');
context = zmq.Context()
sock = context.socket(zmq.SUB)
sock.setsockopt(zmq.SUBSCRIBE, 'telemetry.timing')
sock.connect('tcp://localhost:5566')
while True:
    message = sock.recv()
    if "MTimer.c" in message:
        lines = message.splitlines()
        for line in lines:
            if "TimeIn" in line:
                # set this functions subcalls to false
                if tabLevel > 0:
                    subcalls[tabLevel] = True

                # create the right number of spaces for this level
                spaces = ""
                for n in range(0, tabLevel):
                    spaces = spaces + "  "
                sys.stdout.write("\n" + spaces + GetFunctionName(line))

                # increment the tab level, and set the subcalls for this level to false
                tabLevel = tabLevel + 1

                if len(subcalls) > tabLevel:
                    subcalls[tabLevel] = False
                else:
                    subcalls.append(False)

            elif "Duration" in line:
                if subcalls[tabLevel] == True:
                    spaces = ""
                    for n in range(1, tabLevel):
                        spaces = spaces + "  "
                    sys.stdout.write("\n" + spaces + GetFunctionName(line) + " -> " + GetDurationText(line))
                    subcalls[tabLevel] = False
                else:
                    sys.stdout.write(" -> " + GetDurationText(line))

                if tabLevel > 0:
                    tabLevel = tabLevel - 1
