#!/usr/bin/python
# ====================================================================
# Each class should be written with the follwing in mind
#  init() - Initial call to setup the object
#  run()  - Ran only if init passes
#  offline_mode() - Gather logs and files.
#  diag() - Diagnostics
# ====================================================================

# ====================================================================
# Import from libraries and validate Python version
# ====================================================================
import os
import shutil


class ACviewpoint:
    """Common base class for all Viewpoint diag pieces"""
    def __init__(self):
        self.is_running = False
        self.pid = 0
        self.home_dir = "/opt/viewpoint/"
        self.log_dir = "/opt/viewpoint/log/"
        self.sys_log_vpdir = "/var/log/viewpoint/"
        self.detected = False
        self.active = False
        self.output_dir = "/tmp/"

    # ====================================================================
    #  Initialize - Initial call to setup the object
    # ====================================================================
    def init(self, output_dir):
        self.output_dir = output_dir

    # ====================================================================
    # Run - Ran only if init passes
    # ====================================================================
    def run(self):
        self.gather_viewpoint_diag()

    # ====================================================================
    # Diag - Diagnostics
    # ====================================================================
    def diag(self):
        diag_print = "\n================= VIEWPOINT DIAGS ================="
        diag_print += "\nVP is running : " + str(self.is_running)
        diag_print += "\nVP PID : " + str(self.pid)
        diag_print += "\nVP home dir : " + self.home_dir
        diag_print += "\nVP log dir : " + self.log_dir
        diag_print += "\nVP detected : " + str(self.detected)
        diag_print += "\nVP active : " + str(self.active)
        diag_print += "\nVP output dir : " + self.output_dir
        return diag_print

    # ====================================================================
    # Gather entire viewpoint directory
    # ====================================================================
    def gather_viewpoint_diag(self):
        if os.path.exists(self.home_dir):
            try:
                shutil.copytree(self.home_dir, self.output_dir+"viewpoint")
            except IOError, e:
                print "Unable to gather " + sefl.home_dir, e
            try:
                shutil.copytree(self.sys_log_vpdir, self.output_dir+"viewpoint")
            except IOError, e:
                print "Unable to gather " + sefl.sys_log_vpdir, e
        return 0
