#!/usr/bin/python
  
import sys
import zmq
import os

# the message line looks like:
# "message" : "Description:__MSchedScheduleJobs,Pid:25831,Microseconds:0,Percent:0",

#-----------------------------------------------
# GetDescription
#-----------------------------------------------

def GetDescription(line):
    sections = line.split(",")
    for section in sections:
        if "Description" in section:
            return section.split(":")[2]
    return ""

#-----------------------------------------------
# GetPercent
#-----------------------------------------------

def GetPercent(line):
    sections = line.split(",")
    for section in sections:
        if "Percent" in section:
            tuples = section.split(":")
            return tuples[1].split("\"")[0]
    return ""

#-----------------------------------------------
# Main
#-----------------------------------------------

os.system('clear');

context = zmq.Context()
sock = context.socket(zmq.SUB)
sock.setsockopt(zmq.SUBSCRIBE, 'telemetry.stats')
sock.connect('tcp://localhost:5566')
while True:
    message = sock.recv()
    if "Schedule Phase" in message:
        lines = message.splitlines()
        for line in lines:
            if "Schedule Phase" in line:
                print(line)

