#!/usr/bin/env python

import sys, os
from optparse import OptionParser
from oslib.common import *

logger = get_logger(__name__, __file__)

option_parser = OptionParser(usage='Usage: %prog [options] <NODE>')

def delete_node(node_name):
    logger.info('Attempting to delete OpenStack node %s' % node_name)
    client = get_client(logger)
    if not client:
        return 1
    try:
        delete_nodes(logger, client, [node_name]) 
        logger.info('Finished deletion of node %s' % node_name)
    except Exception as e:
        # This should not happen as all errors are caught in delete_nodes
        # But to be safe, we catch any other exceptions here
        logger.error('Encountered error while deleting node %s: %s' % (node_name, str(e)))
        return 1
    return 0

def main(argv):
    options, args = option_parser.parse_args(argv)
    if len(args) != 1:
        option_parser.print_help()
        sys.exit(1)
    logger.debug('Called with parameters: %s' % ' '.join(sys.argv))
    sys.exit(delete_node(args[0]))

if __name__ == '__main__':
    print 'Please see %s for logs' % logger.handlers[0].stream.name
    main(sys.argv[1:])
